
//	File: proba.cpp

//	Copyright 1999 J.Redfield.

//	C++ source file for Windows specific code for proba filter.



#include <windows.h>


#include "FRecord.h"
#include "resource.h"

#define filterSelectorAbout 	 0
#define filterSelectorParameters 1
#define filterSelectorPrepare	 2
#define filterSelectorStart 	 3
#define filterSelectorContinue	 4
#define filterSelectorFinish	 5

#define userCanceledErr			(-128)



HANDLE hDllInstance = NULL;

										//   ( dll)
										//        "Plugins"

BOOL APIENTRY DLLEntry(HANDLE hInstance, DWORD fdwReason, LPVOID lpReserved)
{
	if (fdwReason == DLL_PROCESS_ATTACH)	
		hDllInstance = hInstance;		//   

	return 1;
}
short ErrorCode = 0;
										//   "" 
LONG FAR PASCAL ProbaDialog (HWND hWnd,WORD wMsg,WORD wParam,LONG lParam)
{
	switch( wMsg )
	{
		case WM_COMMAND:

			switch(LOWORD(wParam))
			{
				case IDCANCEL:
					ErrorCode =  userCanceledErr;

				case IDOK:
					EndDialog( hWnd,0 );
			}
	}
	return 0;
}
										//     
										//    ( )    selector

void ENTRYPOINT (	const short		selector,
					FilterRecord	*fPB,	   //        
					long			*data,	   //     	(    )
					short			*result)   //         
{

	HWND HWnd=NULL;
	PlatformData *platform;

	if(selector==0)	platform = (PlatformData *)(fPB->serialNumber);
		else		platform = (PlatformData *)(fPB->platformData);

	if(platform!=NULL)HWnd = (HWND)platform->hwnd;			//       
	
	if(selector == filterSelectorStart)		//          
	{
		SetRectMy(&fPB->inRect  ,0,0,fPB->imageSize.h, fPB->imageSize.v);  //   
		SetRectMy(&fPB->outRect ,0,0,fPB->imageSize.h, fPB->imageSize.v);  //   
		SetRectMy(&fPB->maskRect,0,0,0,0);								   //  
		fPB->inLoPlane	=0;				   //       ()
		fPB->inHiPlane	=fPB->planes-1;	   //    (  )
		fPB->outLoPlane	=0;
		fPB->outHiPlane	=fPB->planes-1;

	}

	if(selector == filterSelectorContinue)
	{										//  
			if( DialogBox(hDllInstance,"proba",HWnd,(FARPROC)ProbaDialog))
			{
				MessageBox(HWnd, "Can't load dialog box!\n", NULL, MB_OK | MB_APPLMODAL );
				ErrorCode = userCanceledErr;
			}
 			if(ErrorCode){*result=ErrorCode;	return;}	//  

		//  

		for(long row=0;row<fPB->imageSize.v;row++)			//   
			for(long col=0;col<fPB->imageSize.h;col++)		//  
				for(long plane=0;plane<fPB->planes;plane++)	//  	0=R 1=G 2=B 3=Transparency( )
				{
					fPB->outData[fPB->outRowBytes*row + fPB->planes*col + plane]
					=
					fPB->inData [fPB->inRowBytes*(fPB->imageSize.v-row-1)  + fPB->planes*col + plane];
				}

		//  

		SetRectMy(&fPB->inRect  ,0,0,0,0); //      	 
		SetRectMy(&fPB->outRect ,0,0,0,0);
		SetRectMy(&fPB->maskRect,0,0,0,0);
	}

		*result = 0;	//  
		return;	
}
